import { Pipe, PipeTransform } from '@angular/core';

@Pipe({
  name: 'convertAsunto'
})
export class NameAsuntosPipe implements PipeTransform {

  abreviatura: Map<string, string> = new Map()

  private loadAbrv() {
    this.abreviatura.set("ACCIÓN DE INCONSTITUCIONALIDAD", 'A.I.')
    this.abreviatura.set("ACLARACIÓN DE JURISPRUDENCIA", 'A.J.')
    this.abreviatura.set("ACLARACIÓN DE SENTENCIA", 'A.S.')
    this.abreviatura.set("AMPARO DIRECTO", 'A.D.')
    this.abreviatura.set("AMPARO DIRECTO EN REVISIÓN", 'A.D.R.')
    this.abreviatura.set("AMPARO EN REVISIÓN", 'A.R.')
    this.abreviatura.set("ARTÍCULO 100 PÁRRAFO OCTAVO DE LA CONSTITUCIÓN POLÍTICA DE LOS ESTADOS UNIDOS MEXICANOS", 'A100.P8.C.P.E.U.M.')
    this.abreviatura.set("ARTÍCULO 11 DE LEY ORGÁNICA PJF FRACCIÓN IX", 'A11.L.O.P.J.F.F9.')
    this.abreviatura.set("CONFLICTO COMPETENCIAL", 'C.C.')
    this.abreviatura.set("CONFLICTO DE TRABAJO", 'C.T.')
    this.abreviatura.set("CONSULTA A TRÁMITE PREVISTO EN EL PÁRRAFO SEGUNDO DE LA FRACCIÓN II DEL ART. 14 DE LA LEY ORGÁNICA DEL PODER JUDICIAL DE LA FEDERACIÓN", 'C.T.P.P2.F2.A14.L.O.P.J.F.')
    this.abreviatura.set("CONSULTA FORMULADA POR TITULARES DE ÓRGANOS JURISDICCIONALES DEL PODER JUDICIAL DE LA FEDERACIÓN", 'C.F.T.O.J.P.J.F.')
    this.abreviatura.set("CONTRADICCIÓN DE TESIS", 'C.T.')
    this.abreviatura.set("CONTRADICCIÓN DE CRITERIOS (ANTES CONTRADICCIÓN DE TESIS)", 'C.C.(A.C.T.)')
    this.abreviatura.set("CONTROVERSIA CONSTITUCIONAL", 'C.C.')
    this.abreviatura.set("CONTROVERSIA POR EXTRADICIÓN", 'C.E.')
    this.abreviatura.set("CONTROVERSIA PREVISTA EN EL ARTÍCULO 11, FRACCIÓN XX, DE LA LEY ORGÁNICA DEL PODER JUDICIAL DE LA FEDERACIÓN", 'C.P.A11.F20.L.O.P.J.F.')
    this.abreviatura.set("DECLARATORIA GENERAL DE INCONSTITUCIONALIDAD", 'D.G.I.')
    this.abreviatura.set("DENUNCIA DE INCUMPLIMIENTO POR APLICACIÓN DE NORMAS O ACTOS DECLARADOS INVÁLIDOS EN LA CONTROVERSIA CONSTITUCIONAL", 'D.I.A.N.A.D.I.C.C.')
    this.abreviatura.set("DENUNCIA DE REPETICIÓN DEL ACTO RECLAMADO", 'D.R.A.R.')
    this.abreviatura.set("DICTAMEN FINAL DE SOLICITUD DE EJERCICIO DE LA FACULTAD DE INVESTIGACIÓN (ART. 97)", 'D.F.S.E.F.I(ART97).')
    this.abreviatura.set("DILIGENCIA DE JURISDICCIÓN VOLUNTARIA", 'D.J.V.')
    this.abreviatura.set("EXCEPCIÓN DE CONEXIDAD", 'E.C.')
    this.abreviatura.set("EXCEPCIÓN DE FALTA DE PERSONALIDAD", 'E.F.P.')
    this.abreviatura.set("EXCEPCIÓN DE IMPROCEDENCIA DE LA VÍA", 'E.I.V.')
    this.abreviatura.set("EXCEPCIÓN DE INCOMPETENCIA", 'E.I.')
    this.abreviatura.set("EXCEPCIÓN DE LITISPENDENCIA", 'E.L.')
    this.abreviatura.set("EXPEDIENTE SOBRE RECEPCIÓN DE SENTENCIAS DE TRIBUNALES INTERNACIONALES", 'E.R.S.T.I.')
    this.abreviatura.set("EXPEDIENTES EN EJECUCIÓN", 'E.J.')
    this.abreviatura.set("IMPEDIMENTO", 'I.')
    this.abreviatura.set("INCIDENCIA POSTERIOR AL DICTADO DE LA SENTENCIA EN UN JUICIO DEL QUE SE CONOCE EN EJERCICIO DE JURISDICCIÓN ORDINARIA", 'I.P.D.S.J.E.J.O.')
    this.abreviatura.set("INCIDENCIA SURGIDA DENTRO DE UN JUICIO DEL QUE SE CONOCE EN EJERCICIO DE JURISDICCIÓN ORDINARIA", 'I.S.J.E.J.O.')
    this.abreviatura.set("INCIDENTE DE ACLARACIÓN DE SENTENCIA EN LA CONTROVERSIA CONSTITUCIONAL", 'I.A.S.C.C.')
    this.abreviatura.set("INCIDENTE DE ACUMULACIÓN", 'I.A.')
    this.abreviatura.set("INCIDENTE DE CUMPLIMIENTO SUSTITUTO", 'I.C.S.')
    this.abreviatura.set("INCIDENTE DE FALSEDAD", 'I.F.')
    this.abreviatura.set("INCIDENTE DE FALSEDAD DE DOCUMENTOS DE LA CONTROVERSIA CONSTITUCIONAL", 'I.F.D.C.C.')
    this.abreviatura.set("INCIDENTE DE FALSEDAD DE DOCUMENTOS DERIVADO DEL RECURSO DE RECLAMACIÓN DE LA CONTROVERSIA CONSTITUCIONAL", 'I.F.D.D.R.R.C.C.')
    this.abreviatura.set("INCIDENTE DE INCUMPLIMIENTO DE SENTENCIA DERIVADO DE CONTROVERSIA CONSTITUCIONAL", 'I.I.S.D.C.C.')
    this.abreviatura.set("INCIDENTE DE INEJECUCIÓN DE SENTENCIA", 'I.I.S.')
    this.abreviatura.set("INCIDENTE DE INEJECUCIÓN DERIVADO DE DENUNCIA DE REPETICIÓN DEL ACTO RECLAMADO", 'I.I.D.D.R.A.R.')
    this.abreviatura.set("INCIDENTE DE INEJECUCIÓN DERIVADO DE DENUNCIA FUNDADA DE REPETICIÓN DE LA APLICACIÓN EN PERJUICIO DEL DENUNCIANTE DE UNA NORMA GENERAL DECLARADA INCONSTITUCIONAL CON EFECTOS GENERALES", 'I.I.D.D.F.R.A.P.D.D.F.R.A.P.D.N.F.D.I.E.F.')
    this.abreviatura.set("INCIDENTE DE INEJECUCIÓN DERIVADO DE INCIDENTE DE CUMPLIMIENTO SUSTITUTO", 'I.I.D.I.C.S.')
    this.abreviatura.set("INCIDENTE DE INEJECUCIÓN DERIVADO DEL INCUMPLIMIENTO DE UNA DECLARATORIA GENERAL DE INCONSTITUCIONALIDAD", 'I.I.D.I.D.G.I.')
    this.abreviatura.set("INCIDENTE DE LIQUIDACIÓN DE INTERESES", 'I.L.I.')
    this.abreviatura.set("INCIDENTE DE NULIDAD DE ACTUACIONES DE J. ORD. F.", 'I.N.A.J.O.F.')
    this.abreviatura.set("INCIDENTE DE NULIDAD DE NOTIFICACIONES DE LA CONTROVERSIA CONSTITUCIONAL", 'I.N.N.C.C.')
    this.abreviatura.set("INCIDENTE DE PAGO DE HONORARIOS", 'I.P.H.')
    this.abreviatura.set("INCIDENTE DE REPOSICIÓN DE AUTOS", 'I.R.A.')
    this.abreviatura.set("INCIDENTE DE REPOSICIÓN DE AUTOS DE LA CONTROVERSIA CONSTITUCIONAL", 'I.R.A.C.C.')
    this.abreviatura.set("INCIDENTE DE SUSPENSIÓN EN ACCIÓN DE INCONSTITUCIONALIDAD", 'I.S.A.I.')
    this.abreviatura.set("INCIDENTE DE SUSPENSIÓN EN CONTROVERSIA CONSTITUCIONAL", 'I.S.C.C.')
    this.abreviatura.set("INCIDENTE DE SUSPENSIÓN EN CUMPLIMIENTO DE CONVENIOS DE COORDINACIÓN FISCAL", 'I.S.C.C.C.F.')
    this.abreviatura.set("INCIDENTES DERIVADOS DE JUICIOS ORD. FED.", 'I.D.J.O.F')
    this.abreviatura.set("INCONFORMIDAD", 'I.')
    this.abreviatura.set("INCONFORMIDAD EN CUMPLIMIENTO DE REVISIONES ADMINISTRATIVAS", 'I.C.R.A.')
    this.abreviatura.set("INVESTIGACIÓN DERIVADA DE RESPONSABILIDADES ADMINISTRATIVAS", 'I.D.R.A.')
    this.abreviatura.set("JUICIO DE INCONFORMIDAD", 'J.I.')
    this.abreviatura.set("JUICIO ORDINARIO FEDERAL", 'J.O.F.')
    this.abreviatura.set("JUICIO SOBRE CUMPLIMIENTO DE LOS CONVENIOS DE COORDINACIÓN FISCAL", 'J.C.C.C.F.')
    this.abreviatura.set("MODIFICACIÓN DE JURISPRUDENCIA", 'M.J.')
    this.abreviatura.set("PROCEDIMIENTO DE RESPONSABILIDAD ADMINISTRATIVA", 'P.R.A.')
    this.abreviatura.set("QUEJA", 'Q.')
    this.abreviatura.set("QUEJA ADMINISTRATIVA", 'Q.A.')
    this.abreviatura.set("QUEJA EN CONTROVERSIAS CONSTITUCIONALES Y ACCIONES DE INCONSTITUCIONALIDAD", 'Q.E.C.A.I.')
    this.abreviatura.set("RECONOCIMIENTO DE INOCENCIA", 'R.I.')
    this.abreviatura.set("RECURSO DE APELACIÓN", 'R.A.')
    this.abreviatura.set("RECURSO DE DENEGADA APELACIÓN", 'R.D.A.')
    this.abreviatura.set("RECURSO DE INCONFORMIDAD", 'R.I.')
    this.abreviatura.set("RECURSO DE INCONFORMIDAD DERIVADO DE PROCEDIMIENTO DE RESPONSABILIDAD ADMINISTRATIVA", 'R.I.D.P.R.A.')
    this.abreviatura.set("RECURSO DE INCONFORMIDAD PREVISTO EN LA FRACCIÓN IV DEL ARTÍCULO 201 DE LA LEY DE AMPARO", 'R.I.P.A201.F4.L.A.')
    this.abreviatura.set("RECURSO DE INCONFORMIDAD PREVISTO EN LAS FRACCIONES I A III DEL ARTÍCULO 201 DE LA LEY DE AMPARO", 'R.I.P.A201.F1-3.L.A.')
    this.abreviatura.set("RECURSO DE RECLAMACIÓN", 'R.R.')
    this.abreviatura.set("RECURSO DE RECLAMACIÓN DERIVADO DE JUICIO CONTENCIOSO ADMINISTRATIVO", 'R.R.D.J.C.A.')
    this.abreviatura.set("RECURSO DE RECLAMACIÓN DERIVADO DEL JUICIO SOBRE EL CONVENIO DE COORDINACIÓN FISCAL", 'R.R.D.J.C.C.F.')
    this.abreviatura.set("RECURSO DE RECLAMACIÓN EN ACCIONES DE INCONST.", 'R.R.A.I.')
    this.abreviatura.set("RECURSO DE RECLAMACIÓN EN LA CONTROVERSIA CONS.", 'R.R.C.C.')
    this.abreviatura.set("RECURSO DE REVISIÓN EN MATERIA DE SEGURIDAD NACIONAL PREVISTO EN LA LEY GENERAL DE TRANSPARENCIA Y ACCESO A LA INFORMACIÓN PÚBLICA", 'R.R.M.S.N.P.L.G.T.A.I.P.')
    this.abreviatura.set("RECURSO DE REVOCACIÓN", 'R.R.')
    this.abreviatura.set("RECURSO DE SÚPLICA (SOLO ASUNTO DE 1930)", 'R.S.')
    this.abreviatura.set("RECURSO INNOMINADO EN EL PROCEDIMIENTO DE RESPONSABILIDAD ADMINISTRATIVA", 'R.I.P.R.A.')
    this.abreviatura.set("REVISIÓN ADMINISTRATIVA", 'R.A.')
    this.abreviatura.set("REVISIÓN ADMINISTRATIVA (LEY FEDERAL DE PROCEDIMIENTO CONTENCIOSO ADMINISTRATIVO)", 'R.A.(L.F.P.C.A).')
    this.abreviatura.set("REVISIÓN DE LA CONSTITUCIONALIDAD DE LA MATERIA DE CONSULTA POPULAR QUE DERIVA DE LA PETICIÓN FORMULADA POR EL PRESIDENTE DE LA REPÚBLICA","R.C.M.C.P.D.P.F.P.R")
    this.abreviatura.set("REVISIÓN DE CONSTITUCIONALIDAD DE LA MATERIA DE UNA CONSULTA POPULAR CONVOCADA POR EL CONGRESO DE LA UNIÓN", 'R.C.M.C.P.C.C.U.')
    this.abreviatura.set("REVISIÓN EN INCIDENTE DE SUSPENSIÓN", 'R.I.S.')
    this.abreviatura.set("REVISIÓN OFICIOSA DE DECRETOS DE RESTRICCIÓN O SUSPENSIÓN DE DERECHOS, PREVISTA EN EL ARTÍCULO 29 PÁRRAFO ÚLTIMO, DE LA CONSTITUCIÓN POLÍTICA DE LOS ESTADOS UNIDOS MEXICANOS", 'R.O.D.R.S.D.P.A29.PU.C.P.E.U.M.')
    this.abreviatura.set("SOLICITUD DE ATENCIÓN PRIORITARIA", 'S.A.P.')
    this.abreviatura.set("SOLICITUD DE EJERCICIO DE LA FACULTAD DE ATRACCIÓN", 'S.E.F.A.')
    this.abreviatura.set("SOLICITUD DE EJERCICIO DE LA FACULTAD DE ATRACCIÓN PREVISTA EN LA FRACCIÓN III DEL ARTÍCULO 105 DE LA CONSTITUCIÓN POLÍTICA DE LOS ESTADOS UNIDOS MEXICANOS", 'S.E.F.A.P.A105.F3.C.P.E.U.M.')
    this.abreviatura.set("SOLICITUD DE EJERCICIO DE LA FACULTAD PREVISTA EN EL ARTÍCULO 97, PÁRRAFO SEGUNDO, DE LA CONSTITUCIÓN POLÍTICA DE LOS ESTADOS UNIDOS MEXICANOS", 'S.E.F.P.A97.P2.C.P.E.U.M.')
    this.abreviatura.set("SOLICITUD DE REASUNCIÓN DE COMPETENCIA", 'S.R.C.')
    this.abreviatura.set("SOLICITUD DE RESOLUCIÓN PRIORITARIA DE ASUNTOS", 'S.R.P.A.')
    this.abreviatura.set("SOLICITUD DE REVOCACIÓN DE LA SUSPENSIÓN EN LA CONTROVERSIA CONSTITUCIONAL", 'S.R.S.C.C.')
    this.abreviatura.set("SOLICITUD DE SUSTITUCIÓN DE JURISPRUDENCIA", 'S.S.J.')
    this.abreviatura.set("SOLICITUD LEY FEDERAL DE TRANSPARENCIA", 'S.L.F.T.')
    this.abreviatura.set("VARIOS", 'V.')
    this.abreviatura.set("VARIOS EN LA ACCIÓN DE INCONSTITUCIONALIDAD", 'V.A.I.')
    this.abreviatura.set("VARIOS EN LA CONTROVERSIA CONSTITUCIONAL", 'V.C.C.')
  }

  transform(value: any, ...args: unknown[]): string {
    this.loadAbrv()
    let abv: string = ''
    if (value.acumulados) {
      abv = this.abreviatura.has(value.tipoAsunto.toUpperCase()) ? this.abreviatura.get(value.tipoAsunto.toUpperCase()) + 'Y.S.A' + ' ' + value.numeroExpediente + ', ' + value.numeroExpedienteAcumulados.join(',') : ''
    } else if (value.ca) {
      abv = this.abreviatura.has(value.tipoAsunto.toUpperCase()) ? this.abreviatura.get(value.tipoAsunto.toUpperCase()) + ' ' + value.numeroExpediente + '- CA' : ''
    } else {
      abv = this.abreviatura.has(value.tipoAsunto.toUpperCase()) ? this.abreviatura.get(value.tipoAsunto.toUpperCase()) + ' ' + value.numeroExpediente : ''
    }

    return abv;
  }

}
